--- u-boot-2011.06_original/drivers/mtd/spi/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/spi/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -25,14 +25,16 @@
 
 LIB	:= $(obj)libspi_flash.o
 
-COBJS-$(CONFIG_SPI_FLASH)	+= spi_flash.o
-COBJS-$(CONFIG_SPI_FLASH_ATMEL)	+= atmel.o
-COBJS-$(CONFIG_SPI_FLASH_EON)	+= eon.o
+COBJS-$(CONFIG_SPI_FLASH)		+= spi_flash.o
+COBJS-$(CONFIG_SPI_FLASH_CNC1900)	+= cnc1900_spi.o
+COBJS-$(CONFIG_SPI_FLASH_ATMEL)		+= atmel.o
+COBJS-$(CONFIG_SPI_FLASH_EON)		+= eon.o
 COBJS-$(CONFIG_SPI_FLASH_MACRONIX)	+= macronix.o
 COBJS-$(CONFIG_SPI_FLASH_SPANSION)	+= spansion.o
-COBJS-$(CONFIG_SPI_FLASH_SST)	+= sst.o
+COBJS-$(CONFIG_SPI_FLASH_SST)		+= sst.o
 COBJS-$(CONFIG_SPI_FLASH_STMICRO)	+= stmicro.o
 COBJS-$(CONFIG_SPI_FLASH_WINBOND)	+= winbond.o
+COBJS-$(CONFIG_SPI_FLASH_GIGADEVICE)+= gigadevice.o
 COBJS-$(CONFIG_SPI_FRAM_RAMTRON)	+= ramtron.o
 COBJS-$(CONFIG_SPI_M95XXX) += eeprom_m95xxx.o
 
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/spi/spi_flash.c u-boot-2011.06/drivers/mtd/spi/spi_flash.c
--- u-boot-2011.06_original/drivers/mtd/spi/spi_flash.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/spi/spi_flash.c	2014-07-29 17:28:38.819972000 +0800
@@ -6,7 +6,6 @@
  *
  * Licensed under the GPL-2 or later.
  */
-
 #include <common.h>
 #include <malloc.h>
 #include <spi.h>
@@ -36,13 +35,14 @@
 
 	ret = spi_xfer(spi, cmd_len * 8, cmd, NULL, flags);
 	if (ret) {
-		debug("SF: Failed to send command (%zu bytes): %d\n",
+		printf("SF: Failed to send command (%zu bytes): %d\n",
 				cmd_len, ret);
 	} else if (data_len != 0) {
 		ret = spi_xfer(spi, data_len * 8, data_out, data_in, SPI_XFER_END);
-		if (ret)
-			debug("SF: Failed to transfer %zu bytes of data: %d\n",
+		if (ret){
+			printf("SF: Failed to transfer %zu bytes of data: %d\n",
 					data_len, ret);
+		}
 	}
 
 	return ret;
@@ -141,14 +141,15 @@
 	u8 cmd[4];
 
 	erase_size = flash->sector_size;
+	debug("flash->sector_size = %d\n",flash->sector_size);
 	if (offset % erase_size || len % erase_size) {
-		debug("SF: Erase offset/length not multiple of erase size\n");
+		printf("SF: Erase offset/length not multiple of erase size\n");
 		return -1;
 	}
 
 	ret = spi_claim_bus(flash->spi);
 	if (ret) {
-		debug("SF: Unable to claim SPI bus\n");
+		printf("SF: Unable to claim SPI bus\n");
 		return ret;
 	}
 
@@ -175,9 +176,8 @@
 		if (ret)
 			goto out;
 	}
-
-	debug("SF: Successfully erased %lu bytes @ %#x\n",
-	      len * erase_size, start);
+	printf("SF: Successfully erased %lu bytes @ %#x\n",
+	      (long unsigned int)len, start);
 
  out:
 	spi_release_bus(flash->spi);
@@ -235,6 +235,9 @@
 #ifdef CONFIG_SPI_FLASH_WINBOND
 	{ 0, 0xef, spi_flash_probe_winbond, },
 #endif
+#ifdef CONFIG_SPI_FLASH_GIGADEVICE
+	{ 0, 0xc8, spi_flash_probe_gigadevice, },
+#endif
 #ifdef CONFIG_SPI_FRAM_RAMTRON
 	{ 6, 0xc2, spi_fram_probe_ramtron, },
 # undef IDCODE_CONT_LEN
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/spi/spi_flash_internal.h u-boot-2011.06/drivers/mtd/spi/spi_flash_internal.h
--- u-boot-2011.06_original/drivers/mtd/spi/spi_flash_internal.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/spi/spi_flash_internal.h	2014-07-29 17:28:38.819972000 +0800
@@ -74,4 +74,6 @@
 struct spi_flash *spi_flash_probe_sst(struct spi_slave *spi, u8 *idcode);
 struct spi_flash *spi_flash_probe_stmicro(struct spi_slave *spi, u8 *idcode);
 struct spi_flash *spi_flash_probe_winbond(struct spi_slave *spi, u8 *idcode);
+struct spi_flash *spi_flash_probe_gigadevice(struct spi_slave *spi, u8 *idcode);
 struct spi_flash *spi_fram_probe_ramtron(struct spi_slave *spi, u8 *idcode);
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/spi/winbond.c u-boot-2011.06/drivers/mtd/spi/winbond.c
--- u-boot-2011.06_original/drivers/mtd/spi/winbond.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/spi/winbond.c	2014-07-29 17:28:38.819972000 +0800
@@ -48,6 +48,14 @@
 
 static const struct winbond_spi_flash_params winbond_spi_flash_table[] = {
 	{
+		.id			= 0x3014,
+		.l2_page_size		= 8,
+		.pages_per_sector	= 16,
+		.sectors_per_block	= 16,
+		.nr_blocks		= 16,
+		.name			= "W25X80",
+	},
+	{
 		.id			= 0x3015,
 		.l2_page_size		= 8,
 		.pages_per_sector	= 16,
@@ -72,6 +80,14 @@
 		.name			= "W25X64",
 	},
 	{
+		.id			= 0x4014,
+		.l2_page_size		= 8,
+		.pages_per_sector	= 16,
+		.sectors_per_block	= 16,
+		.nr_blocks		= 16,
+		.name			= "W25Q80",
+	},
+	{
 		.id			= 0x4015,
 		.l2_page_size		= 8,
 		.pages_per_sector	= 16,
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/net/cn100.c u-boot-2011.06/drivers/net/cn100.c
--- u-boot-2011.06_original/drivers/net/cn100.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/net/cn100.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,542 @@
+#include <common.h>
+#include <command.h>
+#include <net.h>
+#include <netdev.h>
+#include <asm/io.h> 
+#include <malloc.h>
+#include "cn100.h"
+
+#undef CONFIG_CN100_DEBUG
+
+//#define CONFIG_CN100_DEBUG
+#ifdef CONFIG_CN100_DEBUG
+#define CN100_DBG(fmt,args...) printf(fmt ,##args)
+#else
+#define CN100_DBG(fmt,args...)
+#endif
+
+/* Structure/enum declaration ------------------------------- */
+#define SWAP(x) ( ( ( x >> 24 ) & 0xFF ) | ( ( x >> 8 ) & 0xFF00 ) | ( ( x << 8 ) & 0xFF0000 ) | ( ( x << 24 ) & 0xFF000000 ) )
+
+//#define CONFIG_CN100_DATA_BASE	0x07C00000
+
+#define RX_BUFFER_ITEM_SIZE 		1600
+#define RX_BUFFER_ITEM_NUM 		   	256	
+#define TX_BUFFER_NOD_LEN			( 64 )
+#define TX_BUFFER_DATA_LEN			( 2048 )
+#define TX_BUFFER_LEN				( TX_BUFFER_NOD_LEN +  TX_BUFFER_DATA_LEN )
+#define RX_BUFFER_LEN				( RX_BUFFER_ITEM_SIZE * RX_BUFFER_ITEM_NUM )
+
+
+typedef struct
+{
+	u32 buffer_addr;
+	u32 buffer_len;
+	u32 next_link_item;
+	u32 next_item_valid_flag;
+} tx_buffer_f;
+
+
+typedef struct 
+{
+	u32 rx_buffer_addr[RX_BUFFER_ITEM_NUM];
+	u32 buffer_num;
+} rx_buffer_f;
+
+typedef struct
+{
+	u32 index;
+	u32 shift;
+	u32 ctl_offset;
+	u32 mac_offset;
+
+	unsigned char *tx_buffer;
+	unsigned char *rx_buffer;
+	unsigned char rx_buffer_x[RX_BUFFER_ITEM_SIZE];
+
+	rx_buffer_f rx_buffer_list;
+	tx_buffer_f *tx_buffer_nod;
+
+} cn100_priv;
+
+
+
+int cn100_initialize ( bd_t * bd, int index);
+int cn100_init(struct eth_device *dev, bd_t * bd);
+int cn100_send(struct eth_device *dev, volatile void *, int);
+int cn100_recv(struct eth_device *dev);
+void cn100_halt(struct eth_device *dev);
+int cn100_write_hwaddr (struct eth_device* dev);
+
+static int 	init_eth_hw 	(cn100_priv *priv);
+static int 	release_eth_hw (cn100_priv *priv);
+static int 	init_phy_hw 	(cn100_priv *priv);
+static int 	release_phy_hw (cn100_priv *priv);
+static void set_tx_int 		(cn100_priv *priv, int enable );
+static void set_rx_enable 	(cn100_priv *priv, int enable );
+static void set_rx_int 		(cn100_priv *priv, int enable );
+static int 	set_tx_buffer 	(cn100_priv *priv);
+static int 	set_rx_buffer 	(cn100_priv *priv);
+static void set_hw_clock 	(cn100_priv *priv);
+static int 	set_mac_addr 	(cn100_priv *priv, u8 mac_addr[6] );
+static void cn100_reset		(cn100_priv *priv);
+
+
+#define CN100_outl(r,d) 	( *(volatile u32 *)((r) + CONFIG_CN100_BASEADDRESS) = d )
+#define CN100_inl(r) 		(*(volatile u32 *)((r) + CONFIG_CN100_BASEADDRESS))
+
+#ifdef CONFIG_CN100_DEBUG
+static void cn100_dump_regs(cn100_priv *priv)
+{
+	CN100_DBG("\n");
+	CN100_DBG ( "ETH_CFG_ADDR:			0x%08x\n", CN100_inl(ETH_CFG_ADDR));
+	CN100_DBG ( "ETH_INT_REG_ADDR: 		0x%08x\n", CN100_inl(ETH_INT_REG_ADDR));
+	CN100_DBG ( "ETH_INT_ENB_ADDR: 		0x%08x\n", CN100_inl(ETH_INT_ENB_ADDR));
+	CN100_DBG ( "ETH_TX_DMA_ADDR: 		0x%08x\n", CN100_inl(ETH_TX_DMA_ADDR));
+	CN100_DBG ( "ETH_TX_STATES_ADDR: 	0x%08x\n", CN100_inl(ETH_TX_STATES_ADDR));
+	CN100_DBG ( "ETH_RX_BASE_ADDR: 		0x%08x\n", CN100_inl(ETH_RX_BASE_ADDR));
+	CN100_DBG ( "ETH_RX_CFG_ADDR: 		0x%08x\n", CN100_inl(ETH_RX_CFG_ADDR));
+	CN100_DBG ( "ETH_RX_RD_ADDR:		0x%08x\n", CN100_inl(ETH_RX_RD_ADDR));
+	CN100_DBG ( "ETH_RX_WR_ADDR: 		0x%08x\n", CN100_inl(ETH_RX_WR_ADDR));
+	CN100_DBG ( "ETH_RX_STATES_ADDR: 	0x%08x\n", CN100_inl(ETH_RX_STATES_ADDR));
+	CN100_DBG ( "ETH_MAC_SA_MASK: 		0x%08x\n", CN100_inl(ETH_MAC_SA_MASK));
+	CN100_DBG ( "ETH_MAC_HASH_TAB0: 	0x%08x\n", CN100_inl(ETH_MAC_HASH_TAB0));
+	CN100_DBG ( "ETH_MAC_HASH_TAB1: 	0x%08x\n", CN100_inl(ETH_MAC_HASH_TAB1));
+
+	CN100_DBG ( "ETH_MAC_CFG0: 			0x%08x\n", CN100_inl(ETH_MAC_CFG0));
+	CN100_DBG ( "ETH_MAC_CFG1: 			0x%08x\n", CN100_inl(ETH_MAC_CFG1));
+	CN100_DBG ( "ETH_MAC_IPGT: 			0x%08x\n", CN100_inl(ETH_MAC_IPGT));
+	CN100_DBG ( "ETH_MAC_IPGR: 			0x%08x\n", CN100_inl(ETH_MAC_IPGR));
+	CN100_DBG ( "ETH_MAC_CLRT: 			0x%08x\n", CN100_inl(ETH_MAC_CLRT));
+	CN100_DBG ( "ETH_MAC_MAXF: 			0x%08x\n", CN100_inl(ETH_MAC_MAXF));
+	CN100_DBG ( "ETH_MAC_SUPP: 			0x%08x\n", CN100_inl(ETH_MAC_SUPP));
+	CN100_DBG ( "ETH_MAC_TEST: 			0x%08x\n", CN100_inl(ETH_MAC_TEST));
+	CN100_DBG ( "ETH_MAC_MCFG: 			0x%08x\n", CN100_inl(ETH_MAC_MCFG));
+	CN100_DBG ( "ETH_MAC_MCMD: 			0x%08x\n", CN100_inl(ETH_MAC_MCMD));
+	CN100_DBG ( "ETH_MAC_MADR: 			0x%08x\n", CN100_inl(ETH_MAC_MADR));
+	CN100_DBG ( "ETH_MAC_MWTD: 			0x%08x\n", CN100_inl(ETH_MAC_MWTD));
+	CN100_DBG ( "ETH_MAC_MRDD: 			0x%08x\n", CN100_inl(ETH_MAC_MRDD));
+	CN100_DBG ( "ETH_MAC_MIND: 			0x%08x\n", CN100_inl(ETH_MAC_MIND));
+	CN100_DBG ( "ETH_MAC_SA0: 			0x%08x\n", CN100_inl(ETH_MAC_SA0));
+	CN100_DBG ( "ETH_MAC_SA1: 			0x%08x\n", CN100_inl(ETH_MAC_SA1));
+	CN100_DBG ( "ETH_MAC_SA2: 			0x%08x\n", CN100_inl(ETH_MAC_SA2));
+	CN100_DBG ( "ETH_MAC_TSV0: 			0x%08x\n", CN100_inl(ETH_MAC_TSV0));
+	CN100_DBG ( "ETH_MAC_TSV1: 			0x%08x\n", CN100_inl(ETH_MAC_TSV1));
+	CN100_DBG ( "ETH_MAC_RSV: 			0x%08x\n", CN100_inl(ETH_MAC_RSV));
+	CN100_DBG("\n");
+}
+#endif
+
+static int alloc_eth_mem (cn100_priv *priv)
+{
+	s32 i = 0;
+
+	priv->tx_buffer_nod = memalign(ARCH_DMA_MINALIGN, sizeof(tx_buffer_f));
+	priv->tx_buffer = memalign(ARCH_DMA_MINALIGN, TX_BUFFER_LEN);
+	if(priv->tx_buffer_nod == NULL || priv->tx_buffer == NULL) return -1;
+	priv->tx_buffer_nod->buffer_addr = SWAP((u32)priv->tx_buffer);
+	priv->tx_buffer_nod->buffer_len = 0;
+	priv->tx_buffer_nod->next_link_item = 0;
+	priv->tx_buffer_nod->next_link_item = 0;
+
+	/* init rx buffer struct */
+	priv->rx_buffer_list.buffer_num = RX_BUFFER_ITEM_NUM;
+	priv->rx_buffer = memalign(ARCH_DMA_MINALIGN, RX_BUFFER_ITEM_SIZE * RX_BUFFER_ITEM_NUM);
+	if(priv->rx_buffer == NULL) return -1;
+		
+	for(i = 0; i < priv->rx_buffer_list.buffer_num; i++){
+		priv->rx_buffer_list.rx_buffer_addr[i] = (u32)priv->rx_buffer + RX_BUFFER_ITEM_SIZE * i;
+	}
+	CN100_DBG("tx_buffer_nod = %08x\n", (u32)priv->tx_buffer_nod);
+	CN100_DBG("tx_buffer = %08x\n", (u32)priv->tx_buffer);
+	CN100_DBG("rx_buffer = %08x\n", (u32)priv->rx_buffer);
+	return 0;
+}
+
+static int release_eth_mem (cn100_priv *priv)
+{
+	s32 i = 0;
+
+	if (NULL != priv->tx_buffer){
+		free(priv->tx_buffer);
+		priv->tx_buffer = NULL;
+	}
+
+	if (NULL != priv->tx_buffer_nod){
+		free(priv->tx_buffer_nod);
+		priv->tx_buffer_nod = NULL;
+	}
+
+
+	/* RX */
+	for ( i = 0; i < priv->rx_buffer_list.buffer_num; i ++ )
+	{
+		priv->rx_buffer_list.rx_buffer_addr[i] = 0;
+	}
+	priv->rx_buffer_list.buffer_num = 0;
+	if (NULL != priv->rx_buffer){
+		free(priv->rx_buffer);
+		priv->rx_buffer = NULL;
+	}
+
+	return 0;
+}
+
+
+static void set_tx_int (cn100_priv *priv, int enable )
+{
+	u32 value = 0;
+	value = CN100_inl ( ETH_INT_ENB_ADDR );
+	if ( enable ){
+		value |= ETH_INT_TX;
+	}else{
+		value &= ~ETH_INT_TX;
+	}
+	CN100_outl ( ETH_INT_ENB_ADDR, value );
+}
+
+static int init_eth_hw (cn100_priv *priv)
+{
+	u32 value = 0;
+
+	cn100_reset 	(priv);
+	set_rx_int	  	(priv, 0);
+	set_tx_int	  	(priv, 0);
+	set_rx_enable 	(priv, 0);
+	set_rx_buffer 	(priv);
+
+	CN100_outl 		(ETH_CFG_ADDR, 0x00005500 );
+	CN100_outl 		(ETH_MAC_SUPP, 0x00000100 );
+	CN100_outl 		(ETH_MAC_IPGT, 0x00000015 );
+	CN100_outl 		(ETH_MAC_IPGR, 0x00000c12 );
+	CN100_outl 		(ETH_MAC_SA_MASK, 0x3 );
+	CN100_outl 		(ETH_MAC_HASH_TAB0, 0x0 );
+	CN100_outl 		(ETH_MAC_HASH_TAB1, 0x0 );
+	value = CN100_inl (ETH_MAC_CFG1 );
+	value |= 0x1;
+	CN100_outl 		(ETH_MAC_CFG1, value );
+	set_rx_enable 	(priv, 1);
+	set_rx_int	  	(priv, 1);
+	set_tx_int    	(priv, 1);
+	set_hw_clock  	(priv);
+#ifdef CONFIG_CN100_DEBUG
+	//cn100_dump_regs(priv);
+#endif
+	return 0;
+}
+
+static int release_eth_hw (cn100_priv *priv)
+{
+	/* free interrupt */
+	cn100_reset(priv);
+	return 0;
+}
+
+static int init_phy_hw (cn100_priv *priv)
+{
+    CN100_outl(ETH_MAC_MADR, 6<<8);
+	return 0;
+}
+
+static int release_phy_hw (cn100_priv __attribute__((unused)) *priv)
+{
+	return 0;
+}
+
+static void set_rx_enable (cn100_priv *priv, int enable)
+{
+	u32 value = 0;
+	value = CN100_inl (ETH_MAC_CFG0 );
+	if( enable ){
+		value |= 0x01;
+	}else{
+		value &= 0xFFFFFFFE;
+	}
+	CN100_outl (ETH_MAC_CFG0, value );
+	value = CN100_inl (ETH_RX_CFG_ADDR );
+	if( enable ){
+		value |= 0x80000000;
+	}else{
+		value &= 0x7FFFFFFF;
+	}
+	CN100_outl (ETH_RX_CFG_ADDR, value );
+}
+
+static void set_rx_int (cn100_priv *priv, int enable)
+{
+	u32 value = 0;
+	value = CN100_inl (ETH_INT_ENB_ADDR );
+	if ( enable ){
+		value |= ETH_INT_RX;
+	}else{
+		value &= ~ETH_INT_RX;
+	}
+	CN100_outl (ETH_INT_ENB_ADDR, value );
+}
+
+static void set_hw_clock (cn100_priv *priv)
+{
+	CN100_outl (ETH_MAC_MCFG, 0x1c );
+}
+
+static int set_mac_addr (cn100_priv *priv, u8 mac_addr[6])
+{
+	u32 value = 0;
+	/* Set Node Address */
+	value = (u32)mac_addr[1];
+	value = (value<<8) | mac_addr[0];
+	CN100_outl (ETH_MAC_SA2, value );
+	value = (u32)mac_addr[3];
+	value = (value<<8) | mac_addr[2];
+	CN100_outl (ETH_MAC_SA1, value );
+	value = (u32)mac_addr[5];
+	value = (value<<8) | mac_addr[4];
+	CN100_outl (ETH_MAC_SA0, value );
+/*
+	printf("Setting MAC address to eth%d ", priv->index); 
+	for(value = 0; value < 6; value++){
+		printf("%02x%s", mac_addr[value], value == 5? "\n":":");
+	}
+	*/
+	return 0;
+}
+
+static int set_rx_buffer (cn100_priv *priv)
+{
+	u32 value = 0;
+
+	if ( 0 == priv->rx_buffer_list.buffer_num ){
+		return -1;
+	}
+	/* get virtual map physcial address */
+	value = (u32)priv->rx_buffer;
+	CN100_outl (ETH_RX_BASE_ADDR, ( value >> 3 ) );
+	value = priv->rx_buffer_list.buffer_num;
+	value = ( ( value << 8 ) & 0x7FFF00 ) | ( ( RX_BUFFER_ITEM_SIZE >> 3 ) & 0xFF ) ;
+	CN100_outl (ETH_RX_CFG_ADDR, value );
+	/* set output ptr equal input ptr */
+	value = CN100_inl (ETH_RX_WR_ADDR );
+	CN100_outl (ETH_RX_RD_ADDR, value );
+
+	return 0;
+}
+
+static int set_tx_buffer(cn100_priv *priv)
+{
+	u32 value = 0;
+	if ( NULL == priv->tx_buffer )
+	{
+		return -1;
+	}
+	value = (u32)priv->tx_buffer_nod;
+	CN100_outl (ETH_TX_DMA_ADDR, value );
+	return 0;
+}
+
+/* General Purpose cn100 reset routine */
+static void cn100_reset(cn100_priv *priv)
+{
+	CN100_DBG ( "resetting\n" );
+	u32 value = 0x000000b7;
+	/* disable rx and tx */
+	set_rx_int	  (priv, 0);
+	set_tx_int	  (priv, 0);
+	set_rx_enable (priv, 0);
+
+	CN100_outl ( ETH_MAC_CFG0, 0x00008000 );
+	udelay(1000);
+	CN100_outl ( ETH_MAC_CFG0, 0x00000001 );
+	CN100_outl ( ETH_INT_SET_ADDR, 0 );
+	CN100_outl ( ETH_MAC_CFG1, value );
+	udelay(1000);		/* delay 1ms */
+}
+
+#define SCS_CLK_EN 0xB2100140
+#define CLK_XPORT_MASK (1 << 21)
+
+static void cnc_xport_enable(void)
+{
+	u32 val = __raw_readl(SCS_CLK_EN);
+	__raw_writel(val | CLK_XPORT_MASK, SCS_CLK_EN);
+}
+
+
+/* Initilize cn100 board
+*/
+int cn100_initialize ( bd_t * bd, int index)
+{
+	struct eth_device *dev;
+	cn100_priv *priv;
+
+	dev = (struct eth_device *) malloc (sizeof(*dev));
+	priv = (cn100_priv *) malloc (sizeof(*priv));
+	memset (dev, 0, sizeof(*dev));
+	memset (priv, 0, sizeof(*priv));
+
+	priv->index = index;
+	if(index){
+		priv->shift = 16;
+		priv->ctl_offset = ETH1_CTL_BASE - ETH0_CTL_BASE;
+		priv->mac_offset = ETH1_MAC_BASE - ETH0_MAC_BASE;
+	}
+
+	if ( 0 != alloc_eth_mem (priv)  )
+	{
+		printf ( "alloc eth memory resource fail\n" );
+		release_eth_mem (priv);
+		return 0;
+	}
+
+	dev->priv = priv;
+	dev->init = cn100_init;
+	dev->halt = cn100_halt;
+	dev->send = cn100_send;
+	dev->recv = cn100_recv;
+	dev->write_hwaddr = cn100_write_hwaddr;
+
+	cnc_xport_enable();
+
+	sprintf (dev->name, "CN100:%d", index);
+	eth_register (dev);
+	return 1;
+}
+
+int cn100_init(struct eth_device *dev, bd_t * bis)
+{
+	s32 ret = 0;
+	cn100_priv *priv = (cn100_priv *)dev->priv;
+
+	/* init eth hard register */
+	if ( 0 != ( ret = init_eth_hw (priv) ) )
+	{
+		printf ( "init eth hw resource fail\n");
+		goto ERROR_INIT_ETH_HW;
+	}
+
+	/* init phy hard register */
+	if ( 0 != ( ret = init_phy_hw (priv) ) )
+	{
+		printf ( "init phy resource fail\n");
+		goto ERROR_INIT_PHY_HW;
+	}
+	return 1;
+
+ERROR_INIT_PHY_HW:
+	release_eth_hw (priv);
+ERROR_INIT_ETH_HW:
+	return -2;
+}
+
+int  cn100_write_hwaddr(struct eth_device* dev)
+{
+	cn100_priv *priv = (cn100_priv *)dev->priv;
+	set_mac_addr(priv, dev->enetaddr);
+	return 1;
+}
+
+/*
+   Hardware start transmission.
+   Send a packet to media from the upper layer.
+   */
+int cn100_send(struct eth_device *dev, volatile void *packet, int length)
+{
+	cn100_priv *priv = (cn100_priv *)dev->priv;
+
+	CN100_DBG("eth_send: length: %d\n", length);
+#if 0
+	for (i = 0; i < length; i++)
+	{
+		if (i % 8 == 0)
+		{
+			CN100_DBG("\nSend: 02x: ", i);
+		}
+		CN100_DBG("%02x ", ((unsigned char *) packet)[i]);
+	}
+	CN100_DBG("\n");
+#endif
+	memcpy (priv->tx_buffer, (void *)packet, length);
+	flush_dcache_range((u32)priv->tx_buffer, (u32)priv->tx_buffer + TX_BUFFER_DATA_LEN);
+	priv->tx_buffer_nod->buffer_len = SWAP ( length );
+	flush_dcache_range((u32)priv->tx_buffer_nod, (u32)priv->tx_buffer_nod + TX_BUFFER_NOD_LEN);
+	set_tx_buffer (priv);
+	while ( ! (CN100_inl ( ETH_INT_REG_ADDR ) & ETH_INT_TX) ); 
+
+	/* clr send interrupt */
+	CN100_outl (ETH_INT_CLS_ADDR, ETH_INT_TX);
+	CN100_DBG("transmit done\n\n");
+ #ifdef CONFIG_CN100_DEBUG
+   //cn100_dump_regs();
+ #endif
+	return 0;
+}
+
+/*
+   Stop the interface.
+   The interface is stopped when it is brought.
+   */
+void cn100_halt(struct eth_device *dev)
+{
+	CN100_DBG ( "eth_halt\n" );
+	cn100_reset ((cn100_priv*)dev->priv);
+	CN100_DBG ( "eth_halt finish\n" );
+}
+
+
+/*
+   Received a packet and pass to upper layer
+   */
+int cn100_recv(struct eth_device *dev)
+{
+	u32 RxLen = 0;
+	u32 isr;
+	u32 read_ptr;
+	cn100_priv *priv = (cn100_priv *)dev->priv;
+
+	/* Check packet ready or not */
+	isr = CN100_inl( ETH_INT_REG_ADDR );
+	if(isr & ETH_INT_RX ){
+		CN100_outl ( ETH_INT_CLS_ADDR, ETH_INT_RX );
+	}
+	if ( isr & ETH_INT_TX){
+		CN100_outl ( ETH_INT_CLS_ADDR, ETH_INT_TX );
+	}
+
+/*	do{*/
+		CN100_DBG ( "receiving packet\n");
+		read_ptr = CN100_inl ( ETH_RX_RD_ADDR );
+
+		/* No more packet to process if RX FIFO is empty */
+		if(read_ptr & ETH_FIFO_EMPTY) return 0;
+
+		invalidate_dcache_range(priv->rx_buffer_list.rx_buffer_addr[read_ptr & ETH_FIFO_MASK], 
+			priv->rx_buffer_list.rx_buffer_addr[read_ptr & ETH_FIFO_MASK] + RX_BUFFER_ITEM_SIZE);
+		RxLen = *(volatile u32 *)( priv->rx_buffer_list.rx_buffer_addr[read_ptr & ETH_FIFO_MASK] + 4 );
+		RxLen = SWAP ( RxLen );
+
+		CN100_DBG("rx len: %d\n", RxLen);
+
+		if ( RxLen > RX_BUFFER_ITEM_SIZE - 16 ){
+			printf("rx length too big\n");
+			cn100_reset(priv);
+			init_eth_hw(priv); 
+			RxLen = 0;
+		}else{
+			/* Move data from CN100 */
+			memcpy ( priv->rx_buffer_x,
+				(u32 *)(priv->rx_buffer_list.rx_buffer_addr[read_ptr & ETH_FIFO_MASK] + 8),
+				RxLen );
+			read_ptr++;
+
+			if((read_ptr & ETH_FIFO_MASK ) == ( priv->rx_buffer_list.buffer_num) )
+				read_ptr = (~read_ptr) & ETH_FIFO_TOG;
+
+			CN100_outl ( ETH_RX_RD_ADDR, read_ptr );
+
+			/* Pass to upper layer */
+			CN100_DBG("passing packet to upper layer\n");
+			NetReceive(priv->rx_buffer_x, RxLen);
+		}
+/*	}while(1);*/
+	return RxLen;
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/net/cn100.h u-boot-2011.06/drivers/net/cn100.h
--- u-boot-2011.06_original/drivers/net/cn100.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/net/cn100.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,60 @@
+/* cn100 net driver */
+#ifndef _CN100_H_
+#define _CN100_H_
+
+#define	ETH_CFG_ADDR			( 0x0800 )
+#define	ETH_INT_REG_ADDR        ( 0x0840 )
+#define	ETH_INT_ENB_ADDR        ( 0x0844 )
+#define	ETH_INT_SET_ADDR        ( 0x0848 )
+#define	ETH_INT_CLS_ADDR        ( 0x084c )
+
+#define	ETH_TX_DMA_ADDR        	( priv->ctl_offset + 0x09c0 )
+#define	ETH_TX_STATES_ADDR     	( priv->ctl_offset + 0x09c4 )
+#define	ETH_RX_BASE_ADDR       	( priv->ctl_offset + 0x09c8 )
+#define	ETH_RX_CFG_ADDR        	( priv->ctl_offset + 0x09cc )
+#define	ETH_RX_RD_ADDR         	( priv->ctl_offset + 0x09d0 )
+#define	ETH_RX_WR_ADDR         	( priv->ctl_offset + 0x09d4 )
+#define	ETH_RX_STATES_ADDR     	( priv->ctl_offset + 0x09dc )
+
+#define	ETH_MAC_SA_MASK        	( 0x0a98 )
+#define	ETH_MAC_HASH_TAB0      	( 0x0a9c )
+#define	ETH_MAC_HASH_TAB1      	( 0x0aa0 )
+
+#define	ETH_MAC_CFG0          	( priv->mac_offset + 0x0a40 )
+#define	ETH_MAC_CFG1          	( priv->mac_offset + 0x0a44 )
+#define	ETH_MAC_IPGT          	( priv->mac_offset + 0x0a48 )
+#define	ETH_MAC_IPGR          	( priv->mac_offset + 0x0a4c )
+#define	ETH_MAC_CLRT          	( priv->mac_offset + 0x0a50 )
+#define	ETH_MAC_MAXF          	( priv->mac_offset + 0x0a54 )
+#define	ETH_MAC_SUPP          	( priv->mac_offset + 0x0a58 )
+#define	ETH_MAC_TEST          	( priv->mac_offset + 0x0a5c )
+
+#define	ETH_MAC_MCFG          	( 0x0a60 )
+#define	ETH_MAC_MCMD          	( 0x0a64 )
+#define	ETH_MAC_MADR          	( 0x0a68 )
+#define	ETH_MAC_MWTD          	( 0x0a6c )
+#define	ETH_MAC_MRDD          	( 0x0a70 )
+#define	ETH_MAC_MIND          	( 0x0a74 )
+
+#define	ETH_MAC_SA0           	( priv->mac_offset + 0x0a80 )
+#define	ETH_MAC_SA1           	( priv->mac_offset + 0x0a84 )
+#define	ETH_MAC_SA2           	( priv->mac_offset + 0x0a88 )
+#define	ETH_MAC_TSV0           	( priv->mac_offset + 0x0a8c )
+#define	ETH_MAC_TSV1           	( priv->mac_offset + 0x0a90 )
+#define	ETH_MAC_RSV            	( priv->mac_offset + 0x0a94 )
+
+#define ETH0_CTL_BASE			( 0x09c0 )
+#define ETH0_MAC_BASE			( 0x0a40 )
+#define ETH1_CTL_BASE			( 0x0a00 )
+#define ETH1_MAC_BASE			( 0x0ac0 )
+
+#define ETH_INT_TX				(0x01 << priv->shift)
+#define ETH_INT_RX				(0x02 << priv->shift)
+#define ETH_INT_HALF			(0x04 << priv->shift)
+#define ETH_INT_MASK			(0x07 << priv->shift)
+
+#define ETH_FIFO_EMPTY			0x40000000
+#define ETH_FIFO_TOG			0x80000000
+#define ETH_FIFO_MASK			0x00000FFF
+
+#endif // _CN100_H_
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/net/Makefile u-boot-2011.06/drivers/net/Makefile
--- u-boot-2011.06_original/drivers/net/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/net/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -84,6 +84,7 @@
 COBJS-$(CONFIG_ULI526X) += uli526x.o
 COBJS-$(CONFIG_VSC7385_ENET) += vsc7385.o
 COBJS-$(CONFIG_XILINX_EMACLITE) += xilinx_emaclite.o
+COBJS-$(CONFIG_DRIVER_CN100) += cn100.o
 
 COBJS	:= $(sort $(COBJS-y))
 SRCS	:= $(COBJS:.o=.c)
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/serial/ns16550.c u-boot-2011.06/drivers/serial/ns16550.c
--- u-boot-2011.06_original/drivers/serial/ns16550.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/serial/ns16550.c	2014-11-19 00:41:17.367468000 +0800
@@ -4,12 +4,15 @@
  * modified to use CONFIG_SYS_ISA_MEM and new defines
  */
 
+#include <common.h>
 #include <config.h>
 #include <ns16550.h>
 #include <watchdog.h>
 #include <linux/types.h>
 #include <asm/io.h>
 
+DECLARE_GLOBAL_DATA_PTR;
+
 #define UART_LCRVAL UART_LCR_8N1		/* 8 data, 1 stop, no parity */
 #define UART_MCRVAL (UART_MCR_DTR | \
 		     UART_MCR_RTS)		/* RTS/DTR */
@@ -20,30 +23,34 @@
 #define serial_out(x,y)	outb(x,(ulong)y)
 #define serial_in(y)	inb((ulong)y)
 #else
-#define serial_out(x,y) writeb(x,y)
-#define serial_in(y) 	readb(y)
+#define serial_out(x,y) writel(x,y)
+#define serial_in(y) 	readl(y)
 #endif
 
 #ifndef CONFIG_SYS_NS16550_IER
 #define CONFIG_SYS_NS16550_IER  0x00
 #endif /* CONFIG_SYS_NS16550_IER */
 
+#ifdef CONFIG_UART_LOCK
+extern int otp_check_uart_lock(void);
+#endif
+
 void NS16550_init (NS16550_t com_port, int baud_divisor)
 {
-	serial_out(CONFIG_SYS_NS16550_IER, &com_port->ier);
+	serial_out(CONFIG_SYS_NS16550_IER, &com_port->ier); //0x4 = 0
 #if defined(CONFIG_OMAP) && !defined(CONFIG_OMAP3_ZOOM2)
 	serial_out(0x7, &com_port->mdr1);	/* mode select reset TL16C750*/
 #endif
-	serial_out(UART_LCR_BKSE | UART_LCRVAL, (ulong)&com_port->lcr);
-	serial_out(0, &com_port->dll);
-	serial_out(0, &com_port->dlm);
-	serial_out(UART_LCRVAL, &com_port->lcr);
-	serial_out(UART_MCRVAL, &com_port->mcr);
-	serial_out(UART_FCRVAL, &com_port->fcr);
-	serial_out(UART_LCR_BKSE | UART_LCRVAL, &com_port->lcr);
-	serial_out(baud_divisor & 0xff, &com_port->dll);
-	serial_out((baud_divisor >> 8) & 0xff, &com_port->dlm);
-	serial_out(UART_LCRVAL, &com_port->lcr);
+	serial_out(UART_LCR_BKSE | UART_LCRVAL, (ulong)&com_port->lcr); //0xC = 0x83
+	serial_out(0, &com_port->dll); //0x0 = 0
+	serial_out(0, &com_port->dlm); //0x4 = 0
+	serial_out(UART_LCRVAL, &com_port->lcr); //0xC = 3
+	serial_out(UART_MCRVAL, &com_port->mcr); // 0x10 = 3
+	serial_out(UART_FCRVAL, &com_port->fcr); // 0x8 = 7
+	serial_out(UART_LCR_BKSE | UART_LCRVAL, &com_port->lcr); //0xC = 0x83
+	serial_out(baud_divisor & 0xff, &com_port->dll); //0x0 = 0xF
+	serial_out((baud_divisor >> 8) & 0xff, &com_port->dlm); //0x4 = 0
+	serial_out(UART_LCRVAL, &com_port->lcr); //0xC = 3
 #if defined(CONFIG_OMAP) && !defined(CONFIG_OMAP3_ZOOM2)
 #if defined(CONFIG_APTIX)
 	serial_out(3, &com_port->mdr1);	/* /13 mode so Aptix 6MHz can hit 115200 */
@@ -51,12 +58,15 @@
 	serial_out(0, &com_port->mdr1);	/* /16 is proper to hit 115200 with 48MHz */
 #endif
 #endif /* CONFIG_OMAP */
+#ifdef CONFIG_UART_LOCK
+	gd->uart_locked = otp_check_uart_lock();
+#endif
 }
 
 #ifndef CONFIG_NS16550_MIN_FUNCTIONS
 void NS16550_reinit (NS16550_t com_port, int baud_divisor)
 {
-	serial_out(CONFIG_SYS_NS16550_IER, &com_port->ier);
+	serial_out( ( unsigned int) CONFIG_SYS_NS16550_IER, (volatile unsigned int*)  &com_port->ier);
 	serial_out(UART_LCR_BKSE | UART_LCRVAL, &com_port->lcr);
 	serial_out(0, &com_port->dll);
 	serial_out(0, &com_port->dlm);
@@ -72,8 +82,14 @@
 
 void NS16550_putc (NS16550_t com_port, char c)
 {
-	while ((serial_in(&com_port->lsr) & UART_LSR_THRE) == 0);
-	serial_out(c, &com_port->thr);
+#ifdef CONFIG_UART_LOCK
+	if(!gd->uart_locked){
+#endif
+		while ((serial_in(&com_port->lsr) & UART_LSR_THRE) == 0); // *0x14 & 0x20
+		serial_out(c, &com_port->thr); //0x0 = ?
+#ifdef CONFIG_UART_LOCK
+	}
+#endif
 
 	/*
 	 * Call watchdog_reset() upon newline. This is done here in putc
@@ -88,6 +104,11 @@
 #ifndef CONFIG_NS16550_MIN_FUNCTIONS
 char NS16550_getc (NS16550_t com_port)
 {
+#ifdef CONFIG_UART_LOCK
+	if(gd->uart_locked){
+		while(1)WATCHDOG_RESET();
+	}else{
+#endif
 	while ((serial_in(&com_port->lsr) & UART_LSR_DR) == 0) {
 #ifdef CONFIG_USB_TTY
 		extern void usbtty_poll(void);
@@ -95,12 +116,23 @@
 #endif
 		WATCHDOG_RESET();
 	}
+#ifdef CONFIG_UART_LOCK
+	}
+#endif
 	return serial_in(&com_port->rbr);
 }
 
 int NS16550_tstc (NS16550_t com_port)
 {
+#ifdef CONFIG_UART_LOCK
+	if(gd->uart_locked){
+		return 0;
+	}else{
+#endif
 	return ((serial_in(&com_port->lsr) & UART_LSR_DR) != 0);
+#ifdef CONFIG_UART_LOCK
+	}
+#endif
 }
 
 #endif /* CONFIG_NS16550_MIN_FUNCTIONS */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/spi/dw_spi.c u-boot-2011.06/drivers/spi/dw_spi.c
